<?php
/*
* iRC HTML History script [ANSI]
* by
*  2005 CriS
*  2012 Skurat Denis (a.k.a. Dionys)
* @contact: skiner@inbox.ru
* 
* for MSP (MBot) 1.0.0.2 or Higher
*/

/* CONFIGURATION */
define('SCRIPT_NAME',			'iRC HTML Log');
define('SCRIPT_VERSION',		'1.0.2.3');
define('FILE_TIME_FORMAT',		'd.m.Y H:i:s');
define('FOLDER_TIME_FORMAT',	'd.m.Y H:i:s');
define('SYM_NEWLINE',			chr(0x0D).chr(0x0A));
define('SYM_SLASH',				chr(0x5C));
define('LOG_DIR',				dirname(__FILE__) . SYM_SLASH . mb_SysGetProfileName() . SYM_SLASH);
define('SEC_IN_DAY',			(24 * 60 * 60));
define('HISTORY_SEARCH_DEPTH',	31);


$noup		= FALSE;
$file_error	= FALSE;

$get_dir	= $_GET['dir'];
$get_file	= $_GET['file'];
$get_today	= $_GET['today'];
$get_ystday	= $_GET['yesterday'];

if (empty($get_dir))
{
	$dir		= LOG_DIR;
	$uri_dir	= '';
	$noup		= TRUE;
}
else
{
	$dir = realpath(LOG_DIR . SYM_SLASH . $get_dir);
	if (realpath(LOG_DIR) == $dir)
	{
		$uri_dir	= '';
		$noup		= TRUE;
	}
	else
	{
		$uri_dir = str_replace(LOG_DIR, '', $dir);
	}
}

if (isset($get_today))
{
	$uri_dir	= date("Y") . SYM_SLASH . date("m,F") . SYM_SLASH . date("d,l");
	$dir		= realpath(LOG_DIR . SYM_SLASH . date("Y") . SYM_SLASH . date("m,F") . SYM_SLASH . date("d,l"));
	$noup		= FALSE;
}
else if (isset($get_ystday))
{
	$t			= time() - SEC_IN_DAY;
	$uri_dir	= date("Y", $t) . SYM_SLASH . date("m,F", $t) . SYM_SLASH . date("d,l", $t);
	$dir		= realpath(LOG_DIR . SYM_SLASH . date("Y", $t) . SYM_SLASH . date("m,F", $t) . SYM_SLASH . date("d,l", $t));
	$noup		= FALSE;
}

if (!empty($get_file) && is_file($dir . SYM_SLASH . $get_file))
{
	$file_path	= $dir . SYM_SLASH . $get_file;
	$date		= date("Y.m.d", filemtime($file_path));

	$next_day	= '';
	$prev_day	= '';

	$tday		= filemtime(dirname($file_path));
	$dir_tday	= date("Y", $tday) . SYM_SLASH . date("m,F", $tday) . SYM_SLASH . date("d,l", $tday);
	if ($uri_dir == $dir_tday)
	{
		$nday = $tday;
		for ($i = 0; $i < HISTORY_SEARCH_DEPTH; $i ++)
		{
			$nday		= $nday + SEC_IN_DAY;
			$dir_nday	= realpath(LOG_DIR . SYM_SLASH . date("Y", $nday) . SYM_SLASH . date("m,F", $nday) . SYM_SLASH . date("d,l", $nday)) . SYM_SLASH . $get_file;
			if (@is_file($dir_nday))
			{
				$next_day = '<a href="./?dir='. urlencode(date("Y", $nday) . SYM_SLASH . date("m,F", $nday) . SYM_SLASH . date("d,l", $nday)) .'&amp;file='. urlencode($get_file) .'">&#9675; Next History Record &#8658;</a>';
				break;
			}
		}

		$pday = $tday;
		for ($i = 0; $i < HISTORY_SEARCH_DEPTH; $i ++)
		{
			$pday		= $pday - SEC_IN_DAY;
			$dir_pday	= realpath(LOG_DIR . SYM_SLASH . date("Y", $pday) . SYM_SLASH . date("m,F", $pday) . SYM_SLASH . date("d,l", $pday)) . SYM_SLASH . $get_file;
			if (@is_file($dir_pday))
			{
				$prev_day = '<a href="./?dir='. urlencode(date("Y", $pday) . SYM_SLASH . date("m,F", $pday) . SYM_SLASH . date("d,l", $pday)) .'&amp;file='. urlencode($get_file) .'">&#8656; Prev History Record &#9675;</a>';
				break;
			}
		}
	}

	$html_head =
	'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'. SYM_NEWLINE .
	'<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ru" lang="ru">'. SYM_NEWLINE .
	'<head>'. SYM_NEWLINE .
	'	<meta http-equiv="content-type" content="text/html; charset=Windows-1251" />'. SYM_NEWLINE .
	'	<meta http-equiv="refresh" content="30" />'. SYM_NEWLINE .
	'	<link rel="stylesheet" href="history.css" type="text/css" />'. SYM_NEWLINE .
	'	<title>'. SCRIPT_NAME .' ['. str_replace('.hil', '', $get_file) .'] '. $date .'</title>'. SYM_NEWLINE .
	'	<style>'. SYM_NEWLINE .
	'		img { width: 32px; height: 32px; }'. SYM_NEWLINE .
	'		.Sign { font-family: Tahoma; font-weight: bold; font-size: 10px; color: #909090; }'. SYM_NEWLINE .
	'	</style>'. SYM_NEWLINE .
	'</head>'. SYM_NEWLINE .
	'<body>'. SYM_NEWLINE .
	'	<center>'. SYM_NEWLINE .
	'		<span class=h>'. SYM_NEWLINE .
	'			<b>'. SCRIPT_NAME .' ['. str_replace('.hil', '', $get_file) .'] '. $date .'</b>'. SYM_NEWLINE .
	'		</span>'. SYM_NEWLINE .
	'		<br /><br />'. SYM_NEWLINE .
	'		<font class=Georgia>'. SYM_NEWLINE .
	'			Use <b>Ctrl + F</b> for Search in log.'. SYM_NEWLINE .
	'		</font>'. SYM_NEWLINE .
	'		<br />'. SYM_NEWLINE .
	'		<span class=h>'. SYM_NEWLINE .
	'			<a href="./?dir='. urlencode($uri_dir) .'">Go back to directory</a>&nbsp;<a href="#bottom" name="top" id="top">Scroll to Last Event</a>'. SYM_NEWLINE .
	'			<br />'. SYM_NEWLINE .
	'			'. $prev_day .'&nbsp;'. $next_day . SYM_NEWLINE .
	'		</span>'. SYM_NEWLINE .
	'	</center>'. SYM_NEWLINE .
	'	<hr>'. SYM_NEWLINE .
	'	<table>'. SYM_NEWLINE;

	$html_foot =
	'	</table>'. SYM_NEWLINE .
	'	<hr>'. SYM_NEWLINE .
	'	<center>'. SYM_NEWLINE .
	'		<span class=h>'. SYM_NEWLINE .
	'			'. $prev_day .'&nbsp;'. $next_day . SYM_NEWLINE .
	'			<br />'. SYM_NEWLINE .
	'			<a href="./?dir='. urlencode($uri_dir) .'">Go back to directory</a>&nbsp;<a href="#top" name="bottom" id="bottom">Scroll to First Event</a>'. SYM_NEWLINE .
	'		</span>'. SYM_NEWLINE .
	'		<br />'. SYM_NEWLINE .
	'		<font class=Georgia>'. SYM_NEWLINE .
	'			Use <b>Ctrl + F</b> for Search in log.'. SYM_NEWLINE .
	'		</font>'. SYM_NEWLINE .
	'	</center>'. SYM_NEWLINE .
	'	<br /><br />'. SYM_NEWLINE .
	'	<center>'. SYM_NEWLINE .
	'		<font class=Sign>'. SYM_NEWLINE .
	'			'. SCRIPT_NAME .' '. SCRIPT_VERSION .' by &copy; 2005 CriS, &copy; 2012 Dionys<br />'. SYM_NEWLINE .
	'			PHP Version: '. phpversion() .'<br /><br />'. SYM_NEWLINE .
	'			Achieved with '. $_SERVER['SERVER_SOFTWARE'] .' / '. $_SERVER['SERVER_AUTHOR'] .'<br />'. SYM_NEWLINE .
	'		</font>'. SYM_NEWLINE .
	'	</center>'. SYM_NEWLINE .
	'</body>'. SYM_NEWLINE .
	'</html>';

	print $html_head . file_get_contents($file_path) . $html_foot;
	exit;
}
else
{
	if (!empty($get_file))
	{
		$file_error = TRUE;
	}
}

$html_head =
'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'. SYM_NEWLINE .
'<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ru" lang="ru">'. SYM_NEWLINE .
'<head>'. SYM_NEWLINE .
'	<meta http-equiv="content-type" content="text/html; charset=Windows-1251" />'. SYM_NEWLINE .
'	<meta http-equiv="refresh" content="30" />'. SYM_NEWLINE .
'	<link rel="stylesheet" href="style.css" type="text/css" />'. SYM_NEWLINE .
'	<title>'. SCRIPT_NAME .' ['. $uri_dir .']</title>'. SYM_NEWLINE .
'	<style>'. SYM_NEWLINE .
'		img.title { width: 32px; height: 32px; }'. SYM_NEWLINE .
'		img.row { width: 16px; height: 16px; }'. SYM_NEWLINE .
'		td.title { text-align: center; }'. SYM_NEWLINE .
'		tr.altrow { background-color: #eeeeee; }'. SYM_NEWLINE .
'		tr:hover, tr.hilite { background-color: #aaaaee; }'. SYM_NEWLINE .
'		.Sign { font-family: Tahoma; font-weight: bold; font-size: 10px; color: #909090; }'. SYM_NEWLINE .
'	</style>'. SYM_NEWLINE .
'</head>'. SYM_NEWLINE .
'<body>'. SYM_NEWLINE .
'	<center>'. SYM_NEWLINE .
'	<table class="tabdata" id="resizetab">'. SYM_NEWLINE .
'		<tr>'. SYM_NEWLINE .
'			<td class="title" colspan="2">'. SYM_NEWLINE .
'				<h1>'. SCRIPT_NAME .' ['. $uri_dir .']</h1>'. SYM_NEWLINE .
'				<br />'. SYM_NEWLINE .
'				<a href="'. dirname($_SERVER['SCRIPT_NAME']) .'/?yesterday=1">'. SYM_NEWLINE .
'					<img class="title" src="./yesterday.ico" alt="Yesterday" title="Yesterday" border=0>'. SYM_NEWLINE .
'				</a>'. SYM_NEWLINE .
'				&nbsp;'. SYM_NEWLINE .
'				<a href="'. dirname($_SERVER['SCRIPT_NAME']) .'/">'. SYM_NEWLINE .
'					<img class="title" src="./home.ico" alt="Logs Index" title="Logs Index" border=0>'. SYM_NEWLINE .
'				</a>'. SYM_NEWLINE .
'				&nbsp;'. SYM_NEWLINE .
'				<a href="'. dirname($_SERVER['SCRIPT_NAME']) .'/?today=1">'. SYM_NEWLINE .
'					<img class="title" src="./today.ico" alt="Today" title="Today" border=0>'. SYM_NEWLINE .
'				</a>'. SYM_NEWLINE .
'			</td>'. SYM_NEWLINE .
'		</tr>'. SYM_NEWLINE;

$html_body = '';

$root = @opendir($dir);
if ($root)
{
	$file = @readdir($root);
	while ($file)
	{
		if (is_dir($dir . SYM_SLASH . $file) && $file != '.')
		{
			$dirs[strtolower($file)] = $file;
		}

		if (is_file($dir . SYM_SLASH . $file) && stristr($file, '.hil'))
		{
			$files[strtolower($file)] = $file;
		}

		$file = @readdir($root);
	}

	closedir($root);

	@ksort($dirs);
	@ksort($files);

	if ($file_error)
	{
		$html_body .=
		'		<tr>'. SYM_NEWLINE .
		'			<td colspan="2">'. SYM_NEWLINE .
		'				Can\'t open log file'. SYM_NEWLINE .
		'			</td>'. SYM_NEWLINE .
		'		</tr>'. SYM_NEWLINE;
	}
	
	$html_body .=
	'		<tr>'. SYM_NEWLINE .
	'			<td class="title" nowrap="nowrap">'. SYM_NEWLINE .
	'				Category / Log'. SYM_NEWLINE .
	'			</td>'. SYM_NEWLINE .
	'			<td class="title" align=center>'. SYM_NEWLINE .
	'				Modified'. SYM_NEWLINE .
	'			</td>'. SYM_NEWLINE .
	'		</tr>'. SYM_NEWLINE;

	$altrow_color = FALSE;

	if (@is_array($dirs)) foreach($dirs as $file)
	{
		if ($file == '..' && $noup)
		{
			continue;
		}

		unset($filesize);

		$dir_url = '?dir='. urlencode($uri_dir . SYM_SLASH . $file);

		if ($altrow_color)
		{
			$altrow_color	= FALSE;
			$row_class		= ' class="altrow"';
		}
		else
		{
			$altrow_color	= TRUE;
			$row_class		= '';
		}

		$modified = date(FOLDER_TIME_FORMAT, filemtime($dir . SYM_SLASH . $file));

		if ($file == '..')
		{
			$file		= 'Parent directory';
			$dir_url	= '?dir='. urlencode($uri_dir .'/..');
		}

		$html_body .=
		'		<tr'. $row_class .'>'. SYM_NEWLINE .
		'			<td align=left>'. SYM_NEWLINE .
		'				<a href="'. $dir_url .'">'. SYM_NEWLINE .
		'					<img class="row" src="./Folder.ico" border=0>'. SYM_NEWLINE .
		'					&nbsp;'. $file . SYM_NEWLINE .
		'				</a>'. SYM_NEWLINE .
		'				&nbsp;&nbsp;'. SYM_NEWLINE .
		'			</td>'. SYM_NEWLINE .
		'			<td align=center nowrap>'. SYM_NEWLINE .
		'				'. $modified . SYM_NEWLINE .
		'			</td>'. SYM_NEWLINE .
		'		</tr>'. SYM_NEWLINE;
	}

	if (@is_array($files)) foreach($files as $file)
	{
		$filesize	= filesize($dir . SYM_SLASH . $file);
		$file_size	= $filesize .' b';

		if ((intval($filesize) / 1024) >= 1)
		{
			$file_size = strval(round($filesize / 1024, 2)).' kB';
		}
		if ((intval($filesize) / 1024 / 1024) >= 1)
		{
			$file_size = strval(round($filesize / 1024 / 1024, 2)).' Mb';
		}
		if ((intval($filesize) / 1024 / 1024 / 1024) >= 1)
		{
			$file_size = strval(round($filesize / 1024 / 1024 / 1024, 2)).' Gb';
		}

		$file_url = '?dir='. urlencode($uri_dir) .'&amp;file='. urlencode($file);

		if ($altrow_color)
		{
			$altrow_color	= FALSE;
			$row_class		= ' class="altrow"';
		}
		else
		{
			$altrow_color	= TRUE;
			$row_class		= '';
		}

		$html_body .=
		'		<tr'. $row_class .'>'. SYM_NEWLINE .
		'			<td align=left>'. SYM_NEWLINE .
		'				<a href="'. $file_url .'">'. SYM_NEWLINE .
		'					<img class="row" src="./log.ico" border=0>'. SYM_NEWLINE .
		'					&nbsp;'. str_replace('.hil', '', $file) . SYM_NEWLINE .
		'				</a>'. SYM_NEWLINE .
		'				&nbsp;&nbsp;'. SYM_NEWLINE .
		'			</td>'. SYM_NEWLINE .
		'			<td align=center nowrap>'. SYM_NEWLINE .
						date(FILE_TIME_FORMAT, filemtime($dir . SYM_SLASH . $file)) . SYM_NEWLINE .
		'			</td>'. SYM_NEWLINE .
		'		</tr>'. SYM_NEWLINE;
	}
	
}
else
{
	$html_body .=
	'		<tr>'. SYM_NEWLINE .
	'			<td colspan="2">'. SYM_NEWLINE .
	'				Can\'t open directory'. SYM_NEWLINE .
	'			</td>'. SYM_NEWLINE .
	'		</tr>'. SYM_NEWLINE;
}

$html_foot =
'		<tr>'. SYM_NEWLINE .
'			<td class="title" colspan="2">'. SYM_NEWLINE .
'				'. SCRIPT_NAME .' ['. $uri_dir .']'. SYM_NEWLINE .
'			</td>'. SYM_NEWLINE .
'		</tr>'. SYM_NEWLINE .
'	</table>'. SYM_NEWLINE .
'	</center>'. SYM_NEWLINE .
'	<br /><br />'. SYM_NEWLINE .
'	<center>'. SYM_NEWLINE .
'		<font class=Sign>'. SYM_NEWLINE .
'			'. SCRIPT_NAME .' '. SCRIPT_VERSION .' by &copy; 2005 CriS, &copy; 2012 Dionys<br />'. SYM_NEWLINE .
'			PHP Version: '. phpversion() .'<br /><br />'. SYM_NEWLINE .
'			Achieved with '. $_SERVER['SERVER_SOFTWARE'] .' / '. $_SERVER['SERVER_AUTHOR'] .'<br />'. SYM_NEWLINE .
'		</font>'. SYM_NEWLINE .
'	</center>'. SYM_NEWLINE .
'	<script language="JavaScript" type="text/javascript">'. SYM_NEWLINE .
'		function getWindowHeight()'. SYM_NEWLINE .
'		{'. SYM_NEWLINE .
'			var myHeight = 0;'. SYM_NEWLINE .
'			if (typeof(window.innerWidth) == "number")'. SYM_NEWLINE .
'			{'. SYM_NEWLINE .
'				//Non-IE'. SYM_NEWLINE .
'				myHeight = window.innerHeight;'. SYM_NEWLINE .
'			}'. SYM_NEWLINE .
'			else if (document.documentElement && (document.documentElement.clientWidth || document.documentElement.clientHeight))'. SYM_NEWLINE .
'			{'. SYM_NEWLINE .
'				//IE 6+ in "standards compliant mode"'. SYM_NEWLINE .
'				myHeight = document.documentElement.clientHeight;'. SYM_NEWLINE .
'			}'. SYM_NEWLINE .
'			else if (document.body && (document.body.clientWidth || document.body.clientHeight))'. SYM_NEWLINE .
'			{'. SYM_NEWLINE .
'				//IE 4 compatible'. SYM_NEWLINE .
'				myHeight = document.body.clientHeight;'. SYM_NEWLINE .
'			}'. SYM_NEWLINE .
'			return myHeight;'. SYM_NEWLINE .
'		}'. SYM_NEWLINE .
'		function getWindowWidth()'. SYM_NEWLINE .
'		{'. SYM_NEWLINE .
'			var myWidth = 0;'. SYM_NEWLINE .
'			if (typeof(window.innerWidth) == "number")'. SYM_NEWLINE .
'			{'. SYM_NEWLINE .
'				//Non-IE'. SYM_NEWLINE .
'				myWidth = window.innerWidth;'. SYM_NEWLINE .
'			}'. SYM_NEWLINE .
'			else if (document.documentElement && (document.documentElement.clientWidth || document.documentElement.clientHeight))'. SYM_NEWLINE .
'			{'. SYM_NEWLINE .
'				//IE 6+ in "standards compliant mode"'. SYM_NEWLINE .
'				myWidth = document.documentElement.clientWidth;'. SYM_NEWLINE .
'			}'. SYM_NEWLINE .
'			else if (document.body && (document.body.clientWidth || document.body.clientHeight))'. SYM_NEWLINE .
'			{'. SYM_NEWLINE .
'				//IE 4 compatible'. SYM_NEWLINE .
'				myWidth = document.body.clientWidth;'. SYM_NEWLINE .
'			}'. SYM_NEWLINE .
'			return myWidth;'. SYM_NEWLINE .
'		}'. SYM_NEWLINE .
'		function tabdataInit()'. SYM_NEWLINE .
'		{'. SYM_NEWLINE .
'			var tables = document.getElementsByTagName("table");'. SYM_NEWLINE .
'			for (var t=0; t<tables.length; t++)'. SYM_NEWLINE .
'			{'. SYM_NEWLINE .
'				if ("tabdata" == tables[t].className)'. SYM_NEWLINE .
'				{'. SYM_NEWLINE .
'					var rows = document.getElementsByTagName("tr");'. SYM_NEWLINE .
'					for (var i = 0; i < rows.length; i++)'. SYM_NEWLINE .
'					{'. SYM_NEWLINE .
'						rows[i].onmouseover = function() {'. SYM_NEWLINE .
'							this.className += " hilite";'. SYM_NEWLINE .
'						}'. SYM_NEWLINE .
'						rows[i].onmouseout = function() {'. SYM_NEWLINE .
'							this.className = this.className.replace("hilite", "");'. SYM_NEWLINE .
'						}'. SYM_NEWLINE .
'					}'. SYM_NEWLINE .
'				}'. SYM_NEWLINE .
'			}'. SYM_NEWLINE .
'			document.getElementById("resizetab").width = (getWindowWidth() / 2);'. SYM_NEWLINE .
'		}'. SYM_NEWLINE .
'		window.onload = tabdataInit;'. SYM_NEWLINE .
'	</script>'. SYM_NEWLINE .
'</body>'. SYM_NEWLINE .
'</html>';

print $html_head . $html_body . $html_foot;
?>